import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Vector;
import java.util.logging.Logger;

import javax.swing.DefaultListModel;

import org.apache.commons.lang.StringUtils;

/**
 * @author t-saito
 *
 * ReGfB^[ NazohΉNX
 * http://bryful.blog60.fc2.com/blog-entry-258.html
 * .Nazt@C{fBNgō\B
 * .Nazt@CUTF-8̃eLXgt@C
 */
public class Nazoh {
	private SBDTableModel tbl;
	Logger logger;
	final String CODE="UTF-8";

	public Nazoh( SBDTableModel p_tbl, DefaultListModel p_bookmarks, Logger p_logger ){
		tbl = p_tbl;
		logger = p_logger;
	}

	/**
	 * Psɒǉf[^BJbgԍAAZtA摜
	 */
	int global_num=1;
	int cutnum=0;
	String sb_desc="";
	String sb_words="";
	String sb_img ="";
	float sb_time=0;

	/**
	 * Nazt@ĈPsf[^
	 * @author Owner
	 *
	 */
	enum NZ_TYPE {PARAMS, PARAMSEND, DATA, KOMAINFO, KOMAINFOEND, END, KEYVALUE, OTHER};
	class NAZ_LINE{
		NZ_TYPE type;
		String key; // L[
		String value; //l
		public NAZ_LINE(){
			type = NZ_TYPE.OTHER;
			key="";
			value="";
		}
	}

	/**
	 * C|[gC
	 * @param filename
	 * @throws Exception
	 */
	public void read(String filename) throws Exception{
		String line;
		FileInputStream is = new FileInputStream(filename);
		InputStreamReader in = new InputStreamReader(is, CODE);
		BufferedReader bf = new BufferedReader(in)	;
		int cutnum=1;

		while( ( line = bf.readLine() ) != null ){
			//System.out.println("LINE="+line);
			if( line.length() > 0 ){
				// sȊO
				NAZ_LINE naz_line = splitLine(line);
				if(naz_line!=null){
					logger.info("NAZLINE="+naz_line);
					switch(naz_line.type){
					case KEYVALUE:
						key_value(naz_line);
						break;
					case PARAMS:
						params(naz_line);
						break;
					case PARAMSEND:
						params_end(naz_line);
						break;
					case DATA:
						data(naz_line);
						break;
					case KOMAINFO:
						koma_info(naz_line);
						break;
					case KOMAINFOEND:
						koma_info_end(naz_line);
						break;
					case END:
						end(naz_line);
						break;
					default:
						logger.info("DEFault");
						break;
					}

				}
			}
		}
		bf.close();
		in.close();
		is.close();
		return;
	}

	/**
	 * PR}JnBR[hf[^VK쐬
	 * @param naz_line
	 */
	void koma_info(NAZ_LINE naz_line){
		cutnum=global_num;
		global_num++;
		sb_desc = "";
		sb_words ="";
		sb_time = 0;

	}
	/**
	 * PR}IȂ̂ŃR[hǉ
	 * @param naz_line
	 */
	void koma_info_end(NAZ_LINE naz_line){
		// 2011^9^13@ꎞIɃRgƁB
		//addRow(cutnum, sb_desc, sb_words, sb_img); // ÕR[h
	}
	/**
	 * L[ƒl̃yABl͖B
	 * R[hɒlZbg邱ƂB
	 * @param naz_line
	 */
	void key_value(NAZ_LINE naz_line){
		logger.info("K:"+naz_line.key+" V:"+naz_line.value);
	}
	void params(NAZ_LINE naz_line){

	}
	void params_end(NAZ_LINE naz_line){

	}
	void data(NAZ_LINE naz_line){

	}
	void end(NAZ_LINE naz_line){

	}

	/**
	 * Nazoht@ĈPśB
	 * @param line
	 * @return
	 */
	NAZ_LINE splitLine(String line){

		//String[] kv = StringUtils.split(line, ' ');
		String[] kv = StringUtils.split(line, '\t');
		logger.info("Input="+line);
		if(kv.length<=0){
			logger.info("ret:null");
			return null;
		}
		NAZ_LINE ret=new NAZ_LINE();
		if(kv.length>=1){
			ret.key=kv[0];
		}
		if(kv.length>=2){
			ret.value=kv[1];
		}
		logger.info("Key="+ret.key+" Value="+ret.value);
		if(ret.key.equalsIgnoreCase("*KomaInfo")){
			ret.type = NZ_TYPE.KOMAINFO;
		}else if(ret.key.equalsIgnoreCase("*KomaInfoEnd")){
			ret.type = NZ_TYPE.KOMAINFOEND;
		}else{
			ret.type = NZ_TYPE.KEYVALUE;
		}

		return ret;
	}

	/**
	 * GReɂPsǉ
	 * @param row
	 * @param sb_desc
	 * @param sb_words
	 * @param bmk
	 */
	private void addRow(int row, StringBuilder sb_desc, StringBuilder sb_words, String bmk){
		if(sb_desc == null && sb_words == null){
			return;
		}
		Object[] rec = new Object[SBDTableModel.COLMNNUMBERS];
		rec[SBDTableModel.CUT]= new Float(row);
		//rec[SBDTableModel.IMG]= new String("");
		rec[SBDTableModel.IMG]= "";
		if(sb_desc != null){
			rec[SBDTableModel.DESC] = sb_desc.toString();
		}else{
			rec[SBDTableModel.DESC] = "";
		}
		if(sb_words != null){
			rec[SBDTableModel.WORDS] = sb_words.toString();
		}else{
			rec[SBDTableModel.WORDS] = "";
		}
		/**
		if(sb_words!=null && sb_words.length()>2){
			//rec[SBDTableModel.SEC]= calcWordTime(sb_words);
			rec[SBDTableModel.SEC]= new String("");
		}else{
			rec[SBDTableModel.SEC]= new String("");
		}
		*/
		rec[SBDTableModel.SEC]= "";

		rec[SBDTableModel.KEY]= sbedit.makeKeyUID();
		//System.out.println("ADDcut="+rec[SBDTableModel.CUT]+" desc="+rec[SBDTableModel.DESC].toString()+" word="+rec[SBDTableModel.WORDS].toString());
		tbl.addRow(rec);

	}

	/**
	 * NozoheLXgfBNgo
	 * @param filename
	 * @throws Exception
	 */
	public void write(String filename) throws Exception{
		// փobt@ɒǉĂB
		StringBuilder sb=new StringBuilder();
		BufferedWriter writer=new BufferedWriter(new FileWriter(filename));
		//BufferedWriter writer = new BufferedWriter(	new OutputStreamWriter( new FileOutputStream("filename"), "MS932"));

		// Ŗ{
		for (int i = tbl.getRowCount()-1; i >= 0 ; i--) {
			String desc = tbl.getValueAt(i, SBDTableModel.DESC).toString();
			String words=tbl.getValueAt(i, SBDTableModel.WORDS).toString();
			sb.insert(0,"\r\n");
			sb.insert(0,words);
			sb.insert(0,"\r\n");
			sb.insert(0,desc);
		}

		try{
			writer.write(sb.toString());
			//System.out.println(sb);
		}catch(Exception e){
			e.printStackTrace();
			throw e;
		}finally{
			writer.flush();
			writer.close();
			sb = null;
		}
		return;
	}


}
