import java.awt.Desktop;
import java.awt.Point;
import java.awt.Desktop.Action;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.logging.Logger;

import org.apache.commons.io.FileUtils;

/*
 * Created on 2008/03/29
 * http://hpcgi2.nifty.com/Nekomata/nekojyarashi/wiki.cgi?sbdConvert
 * SDBRo[^֘Ãt@CRs[ƂsNXB
 */

public class Nekomata {
	private Logger logger;

	Nekomata(Logger l) {
		logger = l;
	}

	/**
	 *
	 * @param fromDir
	 * @param sbdfile
	 * @param isoverwrite sbdConvert.js΁Aɂ̂ŃI[o[CgȂ
	 * @return
	 * @throws Exception
	 */
	public boolean copy(String fromDir, String sbdfile, boolean isoverwrite) throws Exception {
		if(fromDir == null || sbdfile == null){
			logger.info("p[^null "+fromDir + " "+sbdfile);
			return false;
		}
		File sbdf = new File(sbdfile);
		String toDir = sbdf.getParent();
		logger.info("ToDIr=" + toDir + "  sbdfile=" + sbdfile + " Name="
				+ sbdf.getName());
		String to_js = toDir + File.separator + "sbdConvert.js";
		logger.info("FromDir=" + fromDir + "  jsf=" + to_js);
		File check = new File(to_js).getCanonicalFile();
		if(check.exists() && !isoverwrite ){
			logger.info("sbdConvert.jsɂ̂ŃRs[Ȃ "+check.getCanonicalPath());
			return false;
		}

		/**
		 * ./sbdConvert.html ./sbdConvert.js ./sbdConvert/ Rs[
		 *
		 * ̂Ƃ ./sbdConvert.js var targetURL ="./readme.sbd";//URL ̍s var
		 * targetURL ="./"+sbdfile+";" ɒuB
		 */
		// htmlRs[
		FileUtils.copyFileToDirectory(new File(fromDir + File.separatorChar
				+ "sbdConvert.html"), new File(toDir), true);
		FileUtils.copyFileToDirectory(new File(fromDir + File.separatorChar
				+ "sbdPlayer.html"), new File(toDir), true);

		// sbdConvert/ fBNgRs[
		File srcDir = new File(fromDir + File.separatorChar + "sbdConvert");
		File destDir = new File(toDir);
		FileUtils.copyDirectoryToDirectory(srcDir, destDir);

		// jsRs[(u)
		String data = FileUtils.readFileToString(new File(fromDir
				+ File.separatorChar + "sbdConvert.js"), "UTF-8");
		data = data.replaceAll("readme.sbd", sbdf.getName());
		FileUtils.writeStringToFile(new File(toDir + File.separatorChar
				+ "sbdConvert.js"), data, "UTF-8");

		data = FileUtils.readFileToString(new File(fromDir
				+ File.separatorChar + "sbdPlayer.js"), "UTF-8");
		data = data.replaceAll("readme.sbd", sbdf.getName());
		FileUtils.writeStringToFile(new File(toDir + File.separatorChar
				+ "sbdPlayer.js"), data, "UTF-8");

		return true;
	}

	public void open(String urlstr, String firefoxDir){
		if(firefoxDir != null){
			// SBDRo[^Firefox
			logger.info("Firefox="+firefoxDir);
			try {
				// firefox̏ꍇ́Afile:///C:/t-saito/sbdconv/sbdConvert/sbdConvert.html
				// ̌`łȂƂ
				urlstr = "file:///" + urlstr;
				Process proc = Runtime.getRuntime().exec(
						new String[] { (String) firefoxDir, urlstr });
				logger.info("FirefoxN@vZX"+proc.toString());
			} catch (Exception e) {
				e.printStackTrace();
				logger.warning(e.toString());
			}
		}else{
			// FirefoxCXg[ĂȂȂ玩OuEU
			logger.info("use BrowserLauncher.openURL");
			try{
				//DesctopAPIg JDK 1.6`̂
				//BrowserLauncher.openURL(urlstr);
				if(Desktop.isDesktopSupported()){
					Desktop dt = Desktop.getDesktop();
					if(dt.isSupported(Action.BROWSE)){
						dt.browse( new URI(urlstr) );
					}
				}

			}catch(IOException ioe){
				logger.warning("W̃C^[lbguEUNs");
				logger.warning(ioe.toString());
			} catch (URISyntaxException e) {
				// URL@(肦Ȃ)
				logger.warning("wvtqk̕@BURL="+urlstr);
				logger.warning(e.toString());
				e.printStackTrace();
			}
		}
	}
}
